module processor_grid 

  implicit none 
 
  integer :: nproc, mype 
  integer :: rowid, colid 
  integer :: idest, isour 
  integer :: nprow, npcol 
  integer :: icontext 
 
contains 
 
  subroutine processor_grid_init( ) 
    integer :: ierr 
    integer :: ndims, dims(2), coor(2) 
    integer :: itest 
    ! 
    !     Initialize BLACS, get processor ID (mype) 
    !     and the number of processors (nproc) 
    !     NOTE: mype = 0, 1, .... nproc - 1 
    ! 
    CALL BLACS_PINFO( mype, nproc ) 
 
    !     find out nprow, npcol so that: 
    !     nprow * npcol = nproc 
 
    CALL gridsetup( nproc, nprow, npcol ) 
 
    !     Get a default BLACS context 
    ! 
    CALL BLACS_GET( -1, 0, icontext ) 
 
    !     Initialize a default BLACS context 
    ! 
    CALL BLACS_GRIDINIT( icontext, 'R', nprow, npcol ) 
 
    !     Get processor coordinates = rowid, colid 
    ! 
    CALL BLACS_GRIDINFO( icontext, nprow, npcol, rowid, colid ) 
 
    WRITE(6,*) 'mype = ', mype, ' row = ', rowid, ' col = ', colid 
    ! 
  end subroutine 
 
  subroutine processor_grid_finalize 
    ! 
    !     Close-up Blacs context 
    ! 
    CALL BLACS_GRIDEXIT( icontext ) 
    ! 
  end subroutine 
 
end module 
 
! 
! 
! 
! 
 
PROGRAM scalapack_example 
  ! 
  USE processor_grid 
  ! 
  implicit none 
  ! 
  integer :: n, nb 
  ! 
  CALL processor_grid_init() 
  ! 
  n  = 2000  !  matrix size 
  nb = 120   !  block size 
  ! 
  CALL sample_pdsyev_call( n, nb ) 
  ! 
  CALL processor_grid_finalize() 
  ! 
END PROGRAM 
 
! 
! 
! 
! 
 
SUBROUTINE SAMPLE_PDSYEV_CALL( n, nb ) 
 
   USE processor_grid 
 
   IMPLICIT NONE 
 
   integer             :: n, nb 
 
   REAL*8              :: t1, t2 
   REAL*8              :: cclock 
   EXTERNAL            :: cclock 
 
   INTEGER             :: lwork 
   INTEGER             :: i, j, ii, jj, info, ml, nl 
   INTEGER             :: descb( 50 ), desca( 50 ), descz( 50 ), idum 
   REAL*8, ALLOCATABLE :: a( :, : ), w( : ), z( :, : ), b( :, : ) 
   REAL*8, ALLOCATABLE :: btmp( :, : ) 
   REAL*8, ALLOCATABLE :: work( : ) 
   REAL*8              :: workp( n ) 
   REAL*8              :: wsize, aval 
   REAL*8              :: rtmp( nproc ) 
   ! 
   INTEGER             :: numroc, INDXL2G 
   EXTERNAL            :: numroc, INDXL2G 
 

      CALL BLACS_BARRIER (icontext, 'A') 
      if ( mype == 0 ) then 
        write (6, fmt="(' Matrix and Block size ',2I5)") N, NB 
      end if 
 
      !     Calculate the LOCAL dimensions of A 
      ! 
      nl = numroc( n, nb, rowid, 0, nprow ) 
      ml  = numroc( n, nb, colid, 0, npcol ) 
 
      ALLOCATE( a( nl, ml), w( n ), z(nl, ml) )  
      ! 
      !     These are basic array descriptors 
      ! 
      CALL DESCINIT( desca, n, n, nb, nb, 0, 0, icontext, nl, info ) 
      CALL DESCINIT( descz, n, n, nb, nb, 0, 0, icontext, nl, info ) 
      ! 
      !     Build a matrix that you can create with 
      !     a one line matlab command:  hilb(n) + diag([1:-1/n:1/n]) 
      ! 
      DO j = 1, n 
         DO i = 1, n 
            IF( i == j ) THEN 
               aval = ( DBLE( n-i+1 ) ) / DBLE( n ) + 1.0d0 / ( DBLE( i+j ) - 1.0d0 ) 
            ELSE 
               aval = 1.0d0 / ( DBLE( i+j ) - 1.0d0 ) 
            END IF 
            CALL PDELSET( a, i, j, desca, aval ) 
         END DO 
      END DO 
 
      if( n <= 16 ) THEN 
         !  
         !   print matrix on standard output 
         ! 
         CALL PDLAPRNT( n, n, a, 1, 1, desca, 0, 0, 'A', 6, workp )  
         ! 
      END IF 
 
      CALL BLACS_BARRIER (icontext, 'A') 
      ! 
      T1 = cclock() 
      ! 
      !  diagonalization driver subroutine 
      ! 
      lwork = -1 
      CALL PDSYEV( 'V', 'U', n, a, 1, 1, desca, w, z, 1, 1, descz, wsize, lwork, info ) 
 
      lwork = INT(wsize) + 1 
      allocate( work( lwork ) ) 
      CALL PDSYEV( 'V', 'U', n, a, 1, 1, desca, w, z, 1, 1, descz, work, lwork, info ) 
 
      deallocate( work ) 
 
      IF( info /= 0 ) THEN 
        PRINT *, ' *** DIAGONALIZATION FAILED ! *** '  
      END IF 
 
      T2 = cclock() 
 
      rtmp = 0.0d0 
      rtmp( mype + 1 ) = t2 - t1 
      ! 
      IF( mype == 0 ) THEN 
        WRITE( 6, * ) 'Seconds for PDSYEV = ', rtmp( mype+1 ) 
      END IF 
 
      if( n <= 16 ) THEN 
        CALL PDLAPRNT( n, n, z, 1, 1, descz, 0, 0, 'Z', 6, workp ) 
      END IF 
 
      ! 
      ! Inserire nel programma scal_esercizio.f90 codice necessario a verificare  
      ! l'ortogonalita' degli autovettori memorizzati nella  
      ! matrice z. 
      ! 
      ! traccia: 
      ! 1) allocare una matrice B opportunamente dimensionata 
      ! 2) definire il descrittore per B 
      ! 3) utilizzare la moltiplicazione di matrici parallela  
      !    SCALAPACK PDGEMM per calcolare B = Z^t Z 
      ! 4) i processori verificano che il proprio sottoblocco di 
      !    B corrisponde a quello della matrice identita',  
      !    utilizzando le funzioni SCALAPACK NUMROC e INDXL2G 
      ! 5) utilizzando cclock monitorare il tempo di esecuzione 
      !    di PDGEMM 
      !     
      ! 
      ALLOCATE( b( nl, ml ) ) 

      CALL DESCINIT( descb, n, n, nb, nb, 0, 0, icontext, nl, info ) 
 
      CALL BLACS_BARRIER ( icontext, 'A') 
      T1 = cclock() 
 
      CALL PDGEMM('t', 'n', n, n, n, 1.0d0, z(1,1), 1, 1, descz, z(1,1), 1, 1, descz, 0.0d0, b(1,1), 1, 1, descb) 
 
      T2 = cclock() 
      rtmp = 0.0d0 
      rtmp( mype + 1 ) = t2 - t1 
 
      IF( mype == 0 ) THEN 
        WRITE( 6, * ) 'GFlop/sec for PDGEMM = ', DBLE(n)**3 / rtmp( mype+1 ) * 1.d-9 
      END IF 
 
      DO j = 1, ml 
         DO i = 1, nl 
            ii = INDXL2G( i, nb, rowid, 0, nprow ) 
            jj = INDXL2G( j, nb, colid, 0, npcol ) 
            IF( ii == jj ) THEN 
               IF( ABS( b( i, j ) - 1.0d0 ) >= 1.0d-8 ) WRITE( 6, * ) 'eigenvector not orthogonal' 
            ELSE 
               IF( ABS( b( i, j ) ) >= 1.0d-8 ) WRITE( 6, * ) 'eigenvector not orthogonal' 
            END IF 
         END DO 
      END DO 
 
      IF( n <= 16 ) THEN 
        CALL PDLAPRNT( n, n, b, 1, 1, descb, 0, 0, 'B', 6, workp ) 
      ELSE 
        WRITE(6,*) ' SUM of B on pe ', mype, ' = ', SUM( b ) 
      END IF 
      ! 
      !     Print out diagonalization time and eigenvalues  
      ! 
      IF( mype == 0 ) THEN 
         DO i = 1, MIN(16,n) 
           PRINT *, ' W(', I, ')=', w( i ), ';' 
         END DO 
      END IF 
      ! 
      DEALLOCATE( a, w, z, b ) 
      ! 
   RETURN 
END SUBROUTINE 
 
! 
! 
! 
 
SUBROUTINE gridsetup( nproc, nprow, npcol ) 
 
! 
! This subroutine factorizes the number of processors (NPROC) 
! into NPROW and NPCOL,  that are the sizes of the 2D processors mesh. 
! 
! Written by Carlo Cavazzoni 
! 
 
      IMPLICIT NONE 
 
      integer nproc,nprow,npcol 
 
      integer sqrtnp,i 
 
      sqrtnp = int( sqrt( dble(nproc) ) + 1 ) 
      do i=1,sqrtnp 
        if(mod(nproc,i).eq.0) nprow = i 
      end do 
 
      npcol = nproc/nprow 
 
      return 
END SUBROUTINE 

program hello
  implicit none
  include 'mpif.h'
  
  integer ierr,me,nprocs,left,right
  integer status(MPI_STATUS_SIZE)

  integer,parameter :: ndata = 1000
  
  real :: a
  real :: b
  real :: somma

  integer i

  call MPI_INIT(ierr)
  call MPI_COMM_SIZE(MPI_COMM_WORLD, nprocs, ierr)
  call MPI_COMM_RANK(MPI_COMM_WORLD, me, ierr)

  a = me
  b = -1

  right = mod(me + 1 , nprocs)
  left =  mod(me - 1 + nprocs , nprocs)


  somma = a

  do i = 1,nprocs-1
     call MPI_SENDRECV(a,1,MPI_REAL,left,0, &
          b,1,MPI_REAL,right,0,MPI_COMM_WORLD,status,ierr)
     a = b
     somma = somma + a
  enddo

  print *,'I am proc ',me,' and somma = ',somma
  call MPI_FINALIZE(ierr)
  
end program hello

!
!     It evolves the equation:
!                             u,t + u,x + u,y = 0
!     Using a Lax scheme.
!     The initial data is a cruddy gaussian.
!     Boundaries are flat: copying the value of the neighbour
!

module transport
  implicit none
  save

  integer, parameter :: NX=100
  integer, parameter :: NY=100
  real, parameter    :: LX=2.0
  real, parameter    :: LY=2.0

  real temp(0:NX+1 , 0:NY+1)
  real temp_new(0:NX+1 , 0:NY+1)


CONTAINS
  !conversions from discrete to real coordinates: can be better
  real function ix2x(ix) 
    integer ix
    ix2x = ix*LX/NX-LX/2
  end function ix2x
  
  real function iy2y(iy)
    integer iy
    iy2y =iy*LY/NY-LY/2
  end function iy2y
  
 
 ! initialize the system with a gaussian temperature distribution 

  subroutine init_transport
    integer ix,iy
    real x,y
    real,parameter :: sigma = 0.1
    real,parameter :: tmax = 100
    
    do iy=1,NY
       do ix=1,NX
          x=ix2x(ix)
          y=iy2y(iy)
          temp(ix,iy) = tmax*exp(-(x**2+y**2)/(2.0*sigma**2))
       enddo
    enddo
    
  end subroutine init_transport
  
  ! save the temperature distribution
  ! the ascii format is suitable for splot gnuplot function
  subroutine save_gnuplot(filename)
    character(len=*) filename
    integer ix,iy

    open(unit=20,file=filename,form='formatted') 
    do iy=1,NY
       do ix=1,NX
          write(20,*) ix,iy,temp(ix,iy)
       enddo
       write(20,*)
    enddo
    
    close(20)
  end subroutine save_gnuplot
  
  subroutine update_boundaries_FLAT
    temp(0   , 1:NY) = temp(1  , 1:NY)
    temp(NX+1, 1:NY) = temp(NX   , 1:NY)

    temp(1:NX , 0)    = temp(1:NX , 1)
    temp(1:NX , NY+1) = temp(1:NX , NY)
  end subroutine update_boundaries_FLAT

  subroutine evolve(dtfact)
    real :: dtfact
    real :: dx,dt
    integer :: ix,iy,count
    real :: temp0, k, max=0.0
    

    dx = 2*LX/NX
    dt = dtfact*dx/sqrt(3.0)
    do iy=1,NY
       do ix=1,NX
          temp0 = temp(ix,iy)
          temp_new(ix,iy) = temp0 - 0.5 * dt * (temp(ix+1,iy)-temp(ix-1,iy)+temp(ix,iy+1)-temp(ix,iy-1)) / dx
       enddo
    enddo
    temp = temp_new

    call update_boundaries_FLAT
    
  end subroutine evolve
end module transport


program prova
  use transport
  implicit none
  integer i

  call init_transport
  call update_boundaries_FLAT

  call save_gnuplot('transport.dat')
  do i=1,500
     call evolve(0.1)
  enddo
  call save_gnuplot('transport_end.dat')




end program prova

program hello
  implicit none
  include 'mpif.h'
   
  integer ierr,me,nprocs
  
  call MPI_INIT(ierr)
  call MPI_COMM_SIZE(MPI_COMM_WORLD, nprocs, ierr)
  call MPI_COMM_RANK(MPI_COMM_WORLD, me, ierr)

  print *,'hello, I am task ',me,' of ',nprocs

  call MPI_FINALIZE(ierr)
  
end program hello

      PROGRAM blacs_test
!
!     BLACS testing program
!     this program tests BLACS basic functionalities
!
!     Carlo Cavazzoni ( c.cavazzoni@cineca.it ), 
!     High Performance Computing Group - CINECA
!

      IMPLICIT NONE

!     .. Local Scalars ..
      INTEGER            :: context, iam, mycol, myrow,
     $                   npcol, nprocs, nprow
!
      !     Initialize the BLACS
!
      CALL BLACS_PINFO( iam, nprocs )

      !     Set the dimension of the 2D processors grid 

      nprow = INT( sqrt( nprocs + 0.1d0 ) )
      npcol = nprocs / nprow
!      nprow = 1
!      npcol = 2

      write (*,100) iam, nprocs, nprow, npcol
100   format(' MYPE ',I3,', NPE ',I3,', NPE ROW ',I3,', NPE COL ',I3) 

      !     Get a default BLACS context
!
      CALL BLACS_GET( -1, 0, context )

      !     Initialize a default BLACS context

      CALL BLACS_GRIDINIT( context, 'R', nprow, npcol )

      !     Given a context, return grid dimensions and row and column index

      CALL BLACS_GRIDINFO( context, nprow, npcol, myrow, mycol )

      !
      WRITE( 6, 10 ) iam, myrow, mycol
 10   FORMAT( 'my id = ', I2, ' my row = ', I2, ' my com = ', I2 )

      IF( mycol .gt. -1 .and. myrow .gt. -1 ) then
        CALL BLACS_BARRIER ( context, 'A')
      endif
!
      IF( mycol .gt. -1 .and. myrow .gt. -1 ) then
        CALL BLACS_GRIDEXIT( context )
      endif
!
      CALL BLACS_EXIT( 0 )
!
      STOP
      END

SUBROUTINE WRAPPERC2F(M, N, A, IA, JA, DESCA, IRPRNT, ICPRNT, LENGHT, ARRAY, NOUT, WORK)
      
  IMPLICIT NONE
  
  INTEGER :: M, N, A, IA, JA, DESCA, IRPRNT, ICPRNT, LENGHT, NOUT
  REAL*8 :: WORK
  INTEGER :: i
  INTEGER :: array(lenght)
  
  CHARACTER(lenght) :: stringa

  do i=1, lenght
     stringa(I:I) = CHAR(array(i))
  end do
 
  call pdlaprnt( m, n, a, ia, ja, desca, irprnt, icprnt, stringa, nout, work)
  
END SUBROUTINE WRAPPERC2F

program hello
  implicit none
  include 'mpif.h'
  
  integer ierr,me,nprocs,left,right
  integer status(MPI_STATUS_SIZE)

!  integer,parameter :: ndata = 1000
  integer,parameter :: ndata = 1000000 ! e cosi', funziona!

  real :: a(ndata)
  real :: b(ndata)

  call MPI_INIT(ierr)
  call MPI_COMM_SIZE(MPI_COMM_WORLD, nprocs, ierr)
  call MPI_COMM_RANK(MPI_COMM_WORLD, me, ierr)

  a = me
  b = -1

  right = mod(me + 1 , nprocs)
  left =  mod(me - 1 + nprocs , nprocs)

  call MPI_SENDRECV(a,ndata,MPI_REAL,right,0, &
       b,ndata,MPI_REAL,left,0,MPI_COMM_WORLD,status,ierr)

  print *,'I am proc ',me,' and I have received b(1) = ',b(1)
  call MPI_FINALIZE(ierr)
  
end program hello

!
!     It evolves the equation:
!                             u,t + u,x + u,y = 0
!     Using a Lax scheme.
!     The initial data is a cruddy gaussian.
!     Boundaries are flat: copying the value of the neighbour
!
! parallel WITHOUT TOPOLOGIES: distributed by columns
! dynamic allocation to decide run-time the size to allocate
! no reminder for teaching purposes

module comms
  implicit none
  save
  include 'mpif.h'
  
  integer :: nprocs
  integer :: proc_me,proc_up,proc_down
  
CONTAINS
  
  subroutine INIT_COMMS
    integer ierr
    call MPI_COMM_SIZE(MPI_COMM_WORLD,nprocs,ierr)
    call MPI_COMM_RANK(MPI_COMM_WORLD,proc_me,ierr)
    
    proc_up = proc_me + 1
    proc_down = proc_me - 1

    ! all the communications from/to MPI_PROC_NULL do nothing
    if (proc_down < 0) proc_down=MPI_PROC_NULL
    if (proc_up >= nprocs) proc_up=MPI_PROC_NULL
  
  end subroutine INIT_COMMS
end module comms


module transport
  use comms
  implicit none
  save
  
  integer, parameter :: NX=100
  integer, parameter :: NY=100
  real, parameter    :: LX=2.0
  real, parameter    :: LY=2.0
  
  integer            :: NLY

  real,allocatable   ::  temp(:,:)
  real,allocatable   ::  temp_new(:,:)
  
CONTAINS
  !conversions from discrete to real coordinates: can be better
  real function ix2x(ix) 
    integer ix
    ix2x = ix*LX/NX-LX/2
  end function ix2x
  
  !! THIS CHANGES: the every processor has a different offset
  !! I pass also the proc_y and I do not use proc_me directy because
  !! saving the file I use this parameter to evaluate the real y coordinate
  !! for all the data of other processors that are saved by 0 however.
  real function iy2y(iy,proc_y)
    integer proc_y
    integer iy
    iy2y =iy*LY/NY-LY/2  + proc_y*NLY*LY/NY
  end function iy2y
  
  ! initialize the system with a gaussian temperature distribution
  ! in parallel, allocate the system too
  subroutine init_transport
    use comms
    integer ix,iy
    real x,y
    real,parameter :: sigma = 0.1
    real,parameter :: tmax = 100
    
    NLY = NY/nprocs
    allocate (     temp(0:NX+1 , 0:NLY+1) )
    allocate ( temp_new(0:NX+1 , 0:NLY+1) )

    !! DO loops on local indeces only
    do iy=1,NLY
       do ix=1,NX
          x=ix2x(ix)
          y=iy2y(iy,proc_me)
          temp(ix,iy) = tmax*exp(-(x**2+y**2)/(2.0*sigma**2))
       enddo
    enddo
    
  end subroutine init_transport
  
  ! save the temperature distribution
  ! the ascii format is suitable for splot gnuplot function
  ! collective, use temp_new as temporary buffer
  subroutine save_gnuplot(filename)
    character(len=*) filename
    integer ix,iy
    integer iproc
    integer ierr
    integer status(MPI_STATUS_SIZE)

    if (proc_me == 0) then
       open(unit=20,file=filename,form='formatted') 
       
       do iy=1,NLY
          do ix=1,NX
             write(20,*) ix2x(ix),iy2y(iy,0),temp(ix,iy)
          enddo
          write(20,*)
       enddo
    
       do iproc=1,nprocs-1
          call MPI_RECV(temp_new,(NX+2)*(NLY+2),MPI_REAL,iproc,0, &
               MPI_COMM_WORLD,status,ierr)
          
          do iy=1,NLY
             do ix=1,NX
                write(20,*) ix2x(ix),iy2y(iy,iproc),temp_new(ix,iy)
             enddo
             write(20,*)
          enddo
       enddo
       
       close(20)
    else
       call MPI_SEND(temp,(NX+2)*(NLY+2),MPI_REAL,0,0,MPI_COMM_WORLD,ierr)
    endif
  end subroutine save_gnuplot
  
  !! NY => NLY
  subroutine update_boundaries_FLAT
    integer status(MPI_STATUS_SIZE)
    integer ierr

    temp(0   ,  1:NLY) = temp(1  , 1:NLY)
    temp(NX+1, 1:NLY) = temp(NX   , 1:NLY)
    
    !! only the lowest has the lower boundary condition
    if (proc_me==0)        temp(1:NX , 0)    = temp(1:NX , 1)
    !! only the highest has the upper boundary condition
    if (proc_me==nprocs-1) temp(1:NX , NLY+1) = temp(1:NX , NLY)

    !! communicate the ghost-cells
    !! lower-down
    call MPI_SENDRECV(temp(1,1),NX,MPI_REAL,proc_down,0, &
         temp(1,NLY+1),NX,MPI_REAL,proc_up,0,MPI_COMM_WORLD,status,ierr)
    !! higher-up
    call MPI_SENDRECV(temp(1,NLY),NX,MPI_REAL,proc_up,0, &
         temp(1,0),NX,MPI_REAL,proc_down,0,MPI_COMM_WORLD,status,ierr)
    
  end subroutine update_boundaries_FLAT
  
  subroutine evolve(dtfact)
    real dtfact
    real dx,dt
    integer ix,iy
    real temp0
    
    dx = 2*LX/NX
    dt = dtfact*dx/sqrt(3.0)
    do iy=1,NLY
       do ix=1,NX
          
          temp0 = temp(ix,iy)
          temp_new(ix,iy) = temp0 - 0.5 * dt * &
               (temp(ix+1,iy)-temp(ix-1,iy)+temp(ix,iy+1)-temp(ix,iy-1)) / dx
          
       enddo
    enddo
    temp = temp_new
    call update_boundaries_FLAT
    
  end subroutine evolve
end module transport


program prova
  use transport
  use comms
  implicit none
  integer i
  integer ierr

  call MPI_INIT(ierr)
  call init_comms
  call init_transport
  call update_boundaries_FLAT
  
  call save_gnuplot('transport.dat')
  do i=1,500
     call evolve(0.1)
  enddo
  call save_gnuplot('transport_end.dat')

  call MPI_FINALIZE(ierr)
  
end program prova

program trasposta

  implicit none
  include "mpif.h"
  
  integer, parameter :: dim = 8 
  integer :: ierr, mype, nprocs
  integer :: k, j, i, count, numRow, sup
  integer, dimension(:,:), allocatable :: mat, buf

  call MPI_Init(ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, nprocs, ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, mype, ierr)

  numRow = dim/nprocs

  allocate(mat(numRow, dim))
  allocate(buf(numRow, dim))

  do j=1, dim
     do i=1, numRow
         mat(i,j)= 1000*(i+mype*numRow)+j
    end do
  end do

! print matrix 
  if(mype.eq.0) then
     print*, "Original matrix"
  end if
  
  do count=0, nprocs-1 
     call MPI_Barrier(MPI_COMM_WORLD, ierr)
     if(mype.eq.count)then
        do i=1, numRow
           print*, mat(i,:)
        end do
     end if
     call MPI_Barrier(MPI_COMM_WORLD, ierr)      
  end do
  
  call MPI_Alltoall(mat, numRow*numRow, MPI_INTEGER, buf, numRow*numRow, MPI_INTEGER, MPI_COMM_WORLD, ierr) 
  mat = buf
  
  do k=1, nprocs
     do j=1, numRow
        do i=1,j-1
           sup=mat(i,((k-1)*numRow)+j);
           mat(i,((k-1)*numRow)+j)=mat(j,((k-1)*numRow)+i);
           mat(j,((k-1)*numRow)+i)=sup;
        end do
     end do
  end do
  
! print transpose
  if(mype.eq.0) then
     print*, "Transpose matrix"
  end if
  
  do count=0, nprocs-1 
     call MPI_Barrier(MPI_COMM_WORLD, ierr)
     if(mype.eq.count)then
        do i=1, numRow
           print*, mat(i,:)
        end do
     end if
     call MPI_Barrier(MPI_COMM_WORLD, ierr)
  end do
  
  deallocate(mat)
  
  call MPI_Finalize(ierr)
  
end program trasposta

program Matmul

  implicit none
  save
  include 'mpif.h'

  character(LEN=50) :: stringa
  
  integer, parameter :: N = 8
  integer :: nprocs, ierr, proc_me, status(MPI_STATUS_SIZE)
  integer :: ncount, i, j, iglob, k, z
  real, allocatable, dimension(:,:) :: A, B, C, buffer
  real, allocatable, dimension(:) :: sup
  integer :: Nrow, Ncol
  
  call MPI_INIT(ierr)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,nprocs,ierr)
  call MPI_COMM_RANK(MPI_COMM_WORLD,proc_me,ierr)

  Nrow = N / nprocs
  NCol = N

  allocate(A(Nrow,Ncol))
  allocate(B(Nrow,Ncol))
  allocate(C(Nrow,Ncol))
  allocate(buffer(Nrow,Ncol))
  allocate(sup(Ncol))

  !---------- inizializzazione delle matrici A e B 
  do j=1,Ncol
     do i=1,Nrow
        A(i,j) = 1.0/j
! ((Nrow * proc_me)+i) * j
        B(i,j) = 2.0/ A(i,j)
        C = 0.0
     enddo
  enddo
  
  write(stringa, *) Ncol



  do ncount=0, nprocs-1
     call MPI_Allgather(B(:, (ncount*Nrow)+1:ncount*Nrow+Nrow), NRow*Nrow, MPI_REAL, buffer, &
                                                     Nrow*Nrow, MPI_REAL, MPI_COMM_WORLD, ierr)
     do k = (ncount*Nrow) + 1, (ncount+1) * Nrow
        do j = 1, Ncol 
           do i = 1, Nrow
              C(i,k) = C(i,k) + A(i,j) * buffer(mod(j-1,NRow)+1,((j/(Nrow+1)*Nrow))+k-(ncount*Nrow))
           end do
        end do
    end do
  end do
  
  if (proc_me == 0) then

! print matrix C
    print*, "Matrix C"
      
    do i=1,Nrow
       print '('//trim(stringa)//'(F8.2))', C(i,:)
    enddo
     
     do k=1, nprocs-1
        call MPI_RECV(C, Nrow*Ncol, MPI_REAL, k, 0, MPI_COMM_WORLD, status, ierr)
        do i=1,Nrow
           print '('//trim(stringa)//'(F8.2))', C(i,:)
        enddo
     enddo
  else
     call MPI_SEND(C, Nrow*Ncol, MPI_REAL, 0, 0, MPI_COMM_WORLD, ierr)
  end if

  call MPI_FINALIZE(ierr)
  
end program Matmul

program hello
  implicit none
  include 'mpif.h'
  
  integer ierr,me,nprocs
  integer status(MPI_STATUS_SIZE)

! data buffer must be large enough to get deadlock
  integer,parameter :: ndata = 10000
  real :: a(ndata)
  real :: b(ndata)

  call MPI_INIT(ierr)
  call MPI_COMM_SIZE(MPI_COMM_WORLD, nprocs, ierr)
  call MPI_COMM_RANK(MPI_COMM_WORLD, me, ierr)

  a = me

  if (nprocs /= 2) then
     print *,'This program must run on 2 processors'
     call MPI_ABORT(ierr)
     stop
  endif
  if (me==0) then
     call MPI_SEND(a,ndata,MPI_REAL,1,0,MPI_COMM_WORLD,ierr)
     call MPI_RECV(b,ndata,MPI_REAL,1,0,MPI_COMM_WORLD,status,ierr)
  else
     call MPI_SEND(a,ndata,MPI_REAL,0,0,MPI_COMM_WORLD,ierr)
     call MPI_RECV(b,ndata,MPI_REAL,0,0,MPI_COMM_WORLD,status,ierr)
  endif

  print *,'I am proc ',me,' and I have received b(1) = ',b(1)
  call MPI_FINALIZE(ierr)
  
end program hello

program distribuite
  implicit none
  
  include 'mpif.h'

  character(LEN=50) :: stringa

  integer, parameter :: N = 17  

  integer ierr, error
  integer status(MPI_STATUS_SIZE)
  
  integer k, i, j, resto, iglob, Ncol, Nrow, sup
  integer me, nprocs

! array distribuito per colonne
  integer, allocatable, dimension(:,:) :: a
  
!--------- fine delle dichiarazioni

!-------- inizializzazioni MPI
  call MPI_INIT(ierr)
  call MPI_COMM_SIZE(MPI_COMM_WORLD, nprocs, ierr)
  call MPI_COMM_RANK(MPI_COMM_WORLD, me, ierr)

  Ncol = N 
  Nrow = N / nprocs

  resto = MOD(N, nprocs)
  if (me < resto) then
     Nrow = Nrow + 1 
  endif

  ALLOCATE(a(Ncol, Nrow))   

  iglob = (Nrow * me) + 1
  if (me >= resto) then
     iglob = iglob + resto
  endif

!---------- inizializzazione dell'array
  do j=1,Nrow
     do i=1,Ncol
        if (i == iglob) then
           A(i,j) = 1.0
        else
           A(i,j) = 0.0
        endif
     enddo
     iglob = iglob + 1;
  enddo

!-------- stampa tutto, per controllo

  write(stringa, *) Ncol

  if (me == 0) then
    do j=1,Nrow
       print '('//trim(stringa)//'(I2))', A(:,j)
    enddo
     
     do k=1, nprocs-1
        if (k==resto) then
           Nrow = Nrow - 1
!           deallocate(A)
!           allocate(A(Ncol,Nrow))
        endif

        call MPI_RECV(A, Nrow*Ncol, MPI_INTEGER, k, 0, MPI_COMM_WORLD, status, ierr)
        do j=1,Nrow
           print '('//trim(stringa)//'(I2))', A(:,j)
        enddo
     enddo
  else
     call MPI_SEND(A, Nrow*Ncol, MPI_INTEGER, 0, 0, MPI_COMM_WORLD, ierr)
  endif
  
  call MPI_FINALIZE(ierr)
  
end program distribuite

!SOMMA AD ALBERO
!sia N numero di processi
!sia M la prima potenza di 2 >= N
!allo step I dell'algoritmo (I comincia da 1) i processi per cui (M - rank) è un multiplo di 2 alla I
!sommano i contributi dei processi rank + 2 alla I-1

Program sumtree
  implicit none
  include 'mpif.h'
  
  integer :: ierr,myid, numprocs, i, d, sum, val, proc
  integer :: status (MPI_Status_size) 
  integer :: M=1
  
  
  call MPI_Init(ierr)
  call MPI_Comm_size(MPI_COMM_WORLD,numprocs,ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD,myid,ierr)
  
  ! M: prima potenza di 2 maggiore di numprocs 
  do while (M < numprocs)
     M = M * 2
  end do
  i = M - myid
  d = 1
  sum = myid
  
  do while (mod(i,2) == 0)

     proc = myid + d
     if (proc < numprocs) then
        call MPI_Recv(val, 1, MPI_INTEGER, proc, 0, MPI_COMM_WORLD, status, ierr)
        sum = sum + val
     endif
     
     i = i / 2
     d = d * 2
  end do
  if (myid == 0) then
     print *, 'Sum =', sum
  else
     proc = myid - d
     call MPI_Send(sum, 1, MPI_INTEGER, proc, 0, MPI_COMM_WORLD,ierr)
  end if
  call MPI_Finalize(ierr)  

end program sumtree
